package org.dromara.art.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.art.domain.bo.ArtSchoolNameBo;
import org.dromara.art.domain.vo.ArtSchoolNameVo;
import org.dromara.art.domain.ArtSchoolName;
import org.dromara.art.mapper.ArtSchoolNameMapper;
import org.dromara.art.service.IArtSchoolNameService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 学校多名称Service业务层处理
 *
 * @author ZhouWenTao
 * @date 2026-02-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ArtSchoolNameServiceImpl implements IArtSchoolNameService {

    private final ArtSchoolNameMapper baseMapper;

    /**
     * 查询学校多名称
     *
     * @param schoolNameId 主键
     * @return 学校多名称
     */
    @Override
    public ArtSchoolNameVo queryById(Long schoolNameId){
        return baseMapper.selectVoById(schoolNameId);
    }

    /**
     * 分页查询学校多名称列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 学校多名称分页列表
     */
    @Override
    public TableDataInfo<ArtSchoolNameVo> queryPageList(ArtSchoolNameBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ArtSchoolName> lqw = buildQueryWrapper(bo);
        Page<ArtSchoolNameVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的学校多名称列表
     *
     * @param bo 查询条件
     * @return 学校多名称列表
     */
    @Override
    public List<ArtSchoolNameVo> queryList(ArtSchoolNameBo bo) {
        LambdaQueryWrapper<ArtSchoolName> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ArtSchoolName> buildQueryWrapper(ArtSchoolNameBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ArtSchoolName> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ArtSchoolName::getSchoolNameId);
        lqw.eq(bo.getSchoolId() != null, ArtSchoolName::getSchoolId, bo.getSchoolId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), ArtSchoolName::getName, bo.getName());
        lqw.eq(bo.getNameType() != null, ArtSchoolName::getNameType, bo.getNameType());
        return lqw;
    }

    /**
     * 新增学校多名称
     *
     * @param bo 学校多名称
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ArtSchoolNameBo bo) {
        ArtSchoolName add = MapstructUtils.convert(bo, ArtSchoolName.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setSchoolNameId(add.getSchoolNameId());
        }
        return flag;
    }

    /**
     * 修改学校多名称
     *
     * @param bo 学校多名称
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ArtSchoolNameBo bo) {
        ArtSchoolName update = MapstructUtils.convert(bo, ArtSchoolName.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ArtSchoolName entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除学校多名称信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
